###
###

.pkgname <- "BSgenome.Ggallus.UCSC.galGal4"

.seqnames <- paste("chr", c(1:28, 32, "M", "W", "Z", "LGE64", "LGE22C19W28_E50C23"), sep="")

.circ_seqs <- "chrM"

.mseqnames <- c("random", "chrUn")

.onLoad <- function(libname, pkgname)
{
    if (pkgname != .pkgname)
        stop("package name (", pkgname, ") is not ",
             "the expected name (", .pkgname, ")")
    extdata_dirpath <- system.file("extdata", package=pkgname,
                                   lib.loc=libname, mustWork=TRUE)

    ## Make and export BSgenome object.
    bsgenome <- BSgenome(
        organism="Gallus gallus",
        species="Chicken",
        provider="UCSC",
        provider_version="galGal4",
        release_date="Nov. 2011",
        release_name="ICGSC Gallus_gallus-4.0",
        source_url="http://hgdownload.cse.ucsc.edu/goldenPath/galGal4/bigZips/",
        seqnames=.seqnames,
        circ_seqs=.circ_seqs,
        mseqnames=.mseqnames,
        seqs_pkgname=pkgname,
        seqs_dirpath=extdata_dirpath
    )

    ns <- asNamespace(pkgname)

    objname <- pkgname
    assign(objname, bsgenome, envir=ns)
    namespaceExport(ns, objname)

    old_objname <- "Ggallus"
    assign(old_objname, bsgenome, envir=ns)
    namespaceExport(ns, old_objname)
}

